"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EC2InstanceConnect = void 0;
const SendSerialConsoleSSHPublicKeyCommand_1 = require("./commands/SendSerialConsoleSSHPublicKeyCommand");
const SendSSHPublicKeyCommand_1 = require("./commands/SendSSHPublicKeyCommand");
const EC2InstanceConnectClient_1 = require("./EC2InstanceConnectClient");
class EC2InstanceConnect extends EC2InstanceConnectClient_1.EC2InstanceConnectClient {
    sendSerialConsoleSSHPublicKey(args, optionsOrCb, cb) {
        const command = new SendSerialConsoleSSHPublicKeyCommand_1.SendSerialConsoleSSHPublicKeyCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    sendSSHPublicKey(args, optionsOrCb, cb) {
        const command = new SendSSHPublicKeyCommand_1.SendSSHPublicKeyCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
}
exports.EC2InstanceConnect = EC2InstanceConnect;
