"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SendSSHPublicKeyResponse = exports.SendSSHPublicKeyRequest = exports.ThrottlingException = exports.ServiceException = exports.SerialConsoleSessionUnavailableException = exports.SerialConsoleSessionLimitExceededException = exports.SerialConsoleAccessDisabledException = exports.SendSerialConsoleSSHPublicKeyResponse = exports.SendSerialConsoleSSHPublicKeyRequest = exports.InvalidArgsException = exports.EC2InstanceTypeInvalidException = exports.EC2InstanceStateInvalidException = exports.EC2InstanceNotFoundException = exports.AuthException = void 0;
const EC2InstanceConnectServiceException_1 = require("./EC2InstanceConnectServiceException");
class AuthException extends EC2InstanceConnectServiceException_1.EC2InstanceConnectServiceException {
    constructor(opts) {
        super({
            name: "AuthException",
            $fault: "client",
            ...opts,
        });
        this.name = "AuthException";
        this.$fault = "client";
        Object.setPrototypeOf(this, AuthException.prototype);
        this.Message = opts.Message;
    }
}
exports.AuthException = AuthException;
class EC2InstanceNotFoundException extends EC2InstanceConnectServiceException_1.EC2InstanceConnectServiceException {
    constructor(opts) {
        super({
            name: "EC2InstanceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "EC2InstanceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, EC2InstanceNotFoundException.prototype);
        this.Message = opts.Message;
    }
}
exports.EC2InstanceNotFoundException = EC2InstanceNotFoundException;
class EC2InstanceStateInvalidException extends EC2InstanceConnectServiceException_1.EC2InstanceConnectServiceException {
    constructor(opts) {
        super({
            name: "EC2InstanceStateInvalidException",
            $fault: "client",
            ...opts,
        });
        this.name = "EC2InstanceStateInvalidException";
        this.$fault = "client";
        Object.setPrototypeOf(this, EC2InstanceStateInvalidException.prototype);
        this.Message = opts.Message;
    }
}
exports.EC2InstanceStateInvalidException = EC2InstanceStateInvalidException;
class EC2InstanceTypeInvalidException extends EC2InstanceConnectServiceException_1.EC2InstanceConnectServiceException {
    constructor(opts) {
        super({
            name: "EC2InstanceTypeInvalidException",
            $fault: "client",
            ...opts,
        });
        this.name = "EC2InstanceTypeInvalidException";
        this.$fault = "client";
        Object.setPrototypeOf(this, EC2InstanceTypeInvalidException.prototype);
        this.Message = opts.Message;
    }
}
exports.EC2InstanceTypeInvalidException = EC2InstanceTypeInvalidException;
class InvalidArgsException extends EC2InstanceConnectServiceException_1.EC2InstanceConnectServiceException {
    constructor(opts) {
        super({
            name: "InvalidArgsException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidArgsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidArgsException.prototype);
        this.Message = opts.Message;
    }
}
exports.InvalidArgsException = InvalidArgsException;
var SendSerialConsoleSSHPublicKeyRequest;
(function (SendSerialConsoleSSHPublicKeyRequest) {
    SendSerialConsoleSSHPublicKeyRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SendSerialConsoleSSHPublicKeyRequest = exports.SendSerialConsoleSSHPublicKeyRequest || (exports.SendSerialConsoleSSHPublicKeyRequest = {}));
var SendSerialConsoleSSHPublicKeyResponse;
(function (SendSerialConsoleSSHPublicKeyResponse) {
    SendSerialConsoleSSHPublicKeyResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SendSerialConsoleSSHPublicKeyResponse = exports.SendSerialConsoleSSHPublicKeyResponse || (exports.SendSerialConsoleSSHPublicKeyResponse = {}));
class SerialConsoleAccessDisabledException extends EC2InstanceConnectServiceException_1.EC2InstanceConnectServiceException {
    constructor(opts) {
        super({
            name: "SerialConsoleAccessDisabledException",
            $fault: "client",
            ...opts,
        });
        this.name = "SerialConsoleAccessDisabledException";
        this.$fault = "client";
        Object.setPrototypeOf(this, SerialConsoleAccessDisabledException.prototype);
        this.Message = opts.Message;
    }
}
exports.SerialConsoleAccessDisabledException = SerialConsoleAccessDisabledException;
class SerialConsoleSessionLimitExceededException extends EC2InstanceConnectServiceException_1.EC2InstanceConnectServiceException {
    constructor(opts) {
        super({
            name: "SerialConsoleSessionLimitExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "SerialConsoleSessionLimitExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, SerialConsoleSessionLimitExceededException.prototype);
        this.Message = opts.Message;
    }
}
exports.SerialConsoleSessionLimitExceededException = SerialConsoleSessionLimitExceededException;
class SerialConsoleSessionUnavailableException extends EC2InstanceConnectServiceException_1.EC2InstanceConnectServiceException {
    constructor(opts) {
        super({
            name: "SerialConsoleSessionUnavailableException",
            $fault: "server",
            ...opts,
        });
        this.name = "SerialConsoleSessionUnavailableException";
        this.$fault = "server";
        Object.setPrototypeOf(this, SerialConsoleSessionUnavailableException.prototype);
        this.Message = opts.Message;
    }
}
exports.SerialConsoleSessionUnavailableException = SerialConsoleSessionUnavailableException;
class ServiceException extends EC2InstanceConnectServiceException_1.EC2InstanceConnectServiceException {
    constructor(opts) {
        super({
            name: "ServiceException",
            $fault: "server",
            ...opts,
        });
        this.name = "ServiceException";
        this.$fault = "server";
        Object.setPrototypeOf(this, ServiceException.prototype);
        this.Message = opts.Message;
    }
}
exports.ServiceException = ServiceException;
class ThrottlingException extends EC2InstanceConnectServiceException_1.EC2InstanceConnectServiceException {
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottlingException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ThrottlingException.prototype);
        this.Message = opts.Message;
    }
}
exports.ThrottlingException = ThrottlingException;
var SendSSHPublicKeyRequest;
(function (SendSSHPublicKeyRequest) {
    SendSSHPublicKeyRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SendSSHPublicKeyRequest = exports.SendSSHPublicKeyRequest || (exports.SendSSHPublicKeyRequest = {}));
var SendSSHPublicKeyResponse;
(function (SendSSHPublicKeyResponse) {
    SendSSHPublicKeyResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SendSSHPublicKeyResponse = exports.SendSSHPublicKeyResponse || (exports.SendSSHPublicKeyResponse = {}));
