import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { SendSSHPublicKeyRequest, SendSSHPublicKeyResponse } from "../models/models_0";
import { deserializeAws_json1_1SendSSHPublicKeyCommand, serializeAws_json1_1SendSSHPublicKeyCommand, } from "../protocols/Aws_json1_1";
var SendSSHPublicKeyCommand = (function (_super) {
    __extends(SendSSHPublicKeyCommand, _super);
    function SendSSHPublicKeyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    SendSSHPublicKeyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2InstanceConnectClient";
        var commandName = "SendSSHPublicKeyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: SendSSHPublicKeyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: SendSSHPublicKeyResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    SendSSHPublicKeyCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1SendSSHPublicKeyCommand(input, context);
    };
    SendSSHPublicKeyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1SendSSHPublicKeyCommand(output, context);
    };
    return SendSSHPublicKeyCommand;
}($Command));
export { SendSSHPublicKeyCommand };
