import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { SendSerialConsoleSSHPublicKeyRequest, SendSerialConsoleSSHPublicKeyResponse } from "../models/models_0";
import { deserializeAws_json1_1SendSerialConsoleSSHPublicKeyCommand, serializeAws_json1_1SendSerialConsoleSSHPublicKeyCommand, } from "../protocols/Aws_json1_1";
var SendSerialConsoleSSHPublicKeyCommand = (function (_super) {
    __extends(SendSerialConsoleSSHPublicKeyCommand, _super);
    function SendSerialConsoleSSHPublicKeyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    SendSerialConsoleSSHPublicKeyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2InstanceConnectClient";
        var commandName = "SendSerialConsoleSSHPublicKeyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: SendSerialConsoleSSHPublicKeyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: SendSerialConsoleSSHPublicKeyResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    SendSerialConsoleSSHPublicKeyCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1SendSerialConsoleSSHPublicKeyCommand(input, context);
    };
    SendSerialConsoleSSHPublicKeyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1SendSerialConsoleSSHPublicKeyCommand(output, context);
    };
    return SendSerialConsoleSSHPublicKeyCommand;
}($Command));
export { SendSerialConsoleSSHPublicKeyCommand };
